commit 09cc01ca00a140c110c02e4ba297da4718f105e8
Author: Richard Biener <rguenther@suse.de>
Date:   Fri Feb 7 14:42:23 2025 +0100

    jit/118780 - make sure to include dlfcn.h when plugin support is disabled
    
    The following makes the dlfcn.h explicitly requested which avoids
    build failure when JIT is enabled but plugin support disabled as
    currently the include is conditional on plugin support.
    
            PR jit/118780
    gcc/
            * system.h: Check INCLUDE_DLFCN_H for including dlfcn.h instead
            of ENABLE_PLUGIN.
            * plugin.cc: Define INCLUDE_DLFCN_H.
    
    gcc/jit/
            * jit-playback.cc: Define INCLUDE_DLFCN_H.
            * jit-result.cc: Likewise.
    
    (cherry picked from commit e22962538f64bb6e5ac87977ec8a5d86f4ef21cb)

diff --git a/gcc/jit/jit-playback.cc b/gcc/jit/jit-playback.cc
index 6baa838af10..799fd195ec6 100644
--- a/gcc/jit/jit-playback.cc
+++ b/gcc/jit/jit-playback.cc
@@ -20,6 +20,7 @@ along with GCC; see the file COPYING3.  If not see
 
 #include "config.h"
 #define INCLUDE_MUTEX
+#define INCLUDE_DLFCN_H
 #include "libgccjit.h"
 #include "system.h"
 #include "coretypes.h"
diff --git a/gcc/jit/jit-result.cc b/gcc/jit/jit-result.cc
index 30770d20f3d..66a767fd361 100644
--- a/gcc/jit/jit-result.cc
+++ b/gcc/jit/jit-result.cc
@@ -19,6 +19,7 @@ along with GCC; see the file COPYING3.  If not see
 <http://www.gnu.org/licenses/>.  */
 
 #include "config.h"
+#define INCLUDE_DLFCN_H
 #include "system.h"
 #include "coretypes.h"
 
diff --git a/gcc/plugin.cc b/gcc/plugin.cc
index aaa7e66888a..b27c6460306 100644
--- a/gcc/plugin.cc
+++ b/gcc/plugin.cc
@@ -21,6 +21,7 @@ along with GCC; see the file COPYING3.  If not see
    APIs described in doc/plugin.texi.  */
 
 #include "config.h"
+#define INCLUDE_DLFCN_H
 #include "system.h"
 #include "coretypes.h"
 #include "options.h"
diff --git a/gcc/system.h b/gcc/system.h
index 1028dcb1eb3..b18482c7190 100644
--- a/gcc/system.h
+++ b/gcc/system.h
@@ -690,7 +690,7 @@ extern int vsnprintf (char *, size_t, const char *, va_list);
 # endif
 #endif
 
-#if defined (ENABLE_PLUGIN) && defined (HAVE_DLFCN_H)
+#if defined (INCLUDE_DLFCN_H) && defined (HAVE_DLFCN_H)
 /* If plugin support is enabled, we could use libdl.  */
 #include <dlfcn.h>
 #endif

